// QVSRPAMDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VCSamp2.h"
#include "QVSRPAMDlg.h"
#include "_qvsrpam.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#import "c:\\tc_nt\\bin\\qvsrpam.exe"  named_guids rename("QVSRPAMLib","qvsrpam")

#define CMD_START_PRINT    0x01     /* start of print command             */
#define CMD_PRINT_DATA     0x400    /* actual print data                  */
#define CMD_END_PRINT      0x02     /* start of print command             */


BEGIN_DISPATCH_MAP(CQVSRPAMDlg, CDialog)
  DISP_FUNCTION_ID(CQVSRPAMDlg, "DisplayEventEx",             102, OnDisplayEventEx, VT_EMPTY, VTS_I4 VTS_BSTR VTS_BSTR VTS_I4)
  DISP_FUNCTION_ID(CQVSRPAMDlg, "PrintEx",                    512, OnPrintExEvent, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_VARIANT)

/*
  DISP_FUNCTION_ID(CQVSRPAMDlg, "OnlineEvent",              001, OnOnlineEvent, VT_EMPTY, VTS_NONE)
  DISP_FUNCTION_ID(CQVSRPAMDlg, "OfflineEvent",             002, OnOfflineEvent, VT_EMPTY, VTS_NONE)
  DISP_FUNCTION_ID(CQVSRPAMDlg, "ConnectTimeoutEvent",      003, OnConnectTimeoutEvent, VT_EMPTY, VTS_NONE)
  DISP_FUNCTION_ID(CQVSRPAMDlg, "DisplayEvent",             101, OnDisplayEvent, VT_EMPTY, VTS_I4 VTS_BSTR VTS_BSTR)
  DISP_FUNCTION_ID(CQVSRPAMDlg, "PrintEvent",               201, OnPrintEvent, VT_EMPTY, VTS_I4 VTS_BSTR VTS_I4)
  DISP_FUNCTION_ID(CQVSRPAMDlg, "AlphaEntryModeEnterEvent", 301, OnAlphaEntryModeEnterEvent, VT_EMPTY, VTS_NONE)
  DISP_FUNCTION_ID(CQVSRPAMDlg, "LockEvent",                304, OnIoprocLockEvent, VT_EMPTY, VTS_NONE)
  DISP_FUNCTION_ID(CQVSRPAMDlg, "UnlockEvent",              307, OnIoprocUnlockEvent, VT_EMPTY, VTS_NONE)
  DISP_FUNCTION_ID(CQVSRPAMDlg, "ScannerUnlockEvent",       410, OnScannerUnlockEvent, VT_EMPTY, VTS_NONE)
  DISP_FUNCTION_ID(CQVSRPAMDlg, "ScannerLockEvent",         411, OnScannerLockEvent, VT_EMPTY, VTS_NONE)
  DISP_FUNCTION_ID(CQVSRPAMDlg, "RunningTotalDataEvent",    412, OnRunningTotalDataEvent, VT_EMPTY, VTS_I4)
  DISP_FUNCTION_ID(CQVSRPAMDlg, "WaitLightEvent",           501, OnWaitLightEvent, VT_EMPTY, VTS_BOOL)
  DISP_FUNCTION_ID(CQVSRPAMDlg, "MessageLightEvent",        502, OnMessageLightEvent, VT_EMPTY, VTS_BOOL)
  DISP_FUNCTION_ID(CQVSRPAMDlg, "OfflineLightEvent",        503, OnOfflineLightEvent, VT_EMPTY, VTS_BOOL)
  DISP_FUNCTION_ID(CQVSRPAMDlg, "FieldLevelInputEvent2",    504, OnFieldLevelInputEvent2, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL VTS_I4)
  DISP_FUNCTION_ID(CQVSRPAMDlg, "DrawerOpenEvent",          505, OnDrawerOpenEvent, VT_EMPTY, VTS_I4)
  DISP_FUNCTION_ID(CQVSRPAMDlg, "TotalsWriteEvent",         506, OnTotalsWriteEvent, VT_EMPTY, VTS_VARIANT VTS_I4 VTS_I4)
  DISP_FUNCTION_ID(CQVSRPAMDlg, "TotalsReadEvent",          507, OnTotalsReadEvent, VT_EMPTY, VTS_I4 VTS_I4)
  DISP_FUNCTION_ID(CQVSRPAMDlg, "LockMSR",                  509, OnLockMSREvent, VT_EMPTY, VTS_NONE)
  DISP_FUNCTION_ID(CQVSRPAMDlg, "UnlockMSR",                510, OnUnlockMSREvent, VT_EMPTY, VTS_NONE)
  DISP_FUNCTION_ID(CQVSRPAMDlg, "ScaleRead",                511, OnScaleReadEvent, VT_EMPTY, VTS_NONE)
  DISP_FUNCTION_ID(CQVSRPAMDlg, "ToneEvent",                513, OnToneEvent, VT_EMPTY, VTS_I4 VTS_I4)
*/
END_DISPATCH_MAP()

/////////////////////////////////////////////////////////////////////////////
// CQVSRPAMDlg dialog


CQVSRPAMDlg::CQVSRPAMDlg(CWnd* pParent /*=NULL*/)
        : CDialog(CQVSRPAMDlg::IDD, pParent)
{
        //{{AFX_DATA_INIT(CQVSRPAMDlg)
                // NOTE: the ClassWizard will add member initialization here
        //}}AFX_DATA_INIT
}


void CQVSRPAMDlg::OnFinalRelease()
{
        // When the last reference for an automation object is released
        // OnFinalRelease is called.  The base class will automatically
        // deletes the object.  Add additional cleanup required for your
        // object before calling the base class.

        CDialog::OnFinalRelease();
}

void CQVSRPAMDlg::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CQVSRPAMDlg)
                // NOTE: the ClassWizard will add DDX and DDV calls here
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CQVSRPAMDlg, CDialog)
        //{{AFX_MSG_MAP(CQVSRPAMDlg)
        ON_BN_CLICKED(IDC_STARTTERM, OnStartterm)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Note: we add support for IID_IQVSRPAMDlg to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the
//  dispinterface in the .ODL file.

// {E1B88BE2-9352-4E3C-8E6B-4DBCF7AB3D6D}
static const IID IID_IQVSRPAMDlg =
{ 0xe1b88be2, 0x9352, 0x4e3c, { 0x8e, 0x6b, 0x4d, 0xbc, 0xf7, 0xab, 0x3d, 0x6d } };

BEGIN_INTERFACE_MAP(CQVSRPAMDlg, CDialog)
        INTERFACE_PART(CQVSRPAMDlg, IID_IQVSRPAMDlg, Dispatch)
        INTERFACE_PART(CQVSRPAMDlg, __uuidof(qvsrpam::_IQVSRPAMEvents), Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CQVSRPAMDlg message handlers

void CQVSRPAMDlg::OnStartterm()
{
   Printer = Term.GetPrinter();
   Printer.SetDeviceID(52);
   Printer.SetDeviceResponseMode(0);

   Term.Connect();
}

BOOL CQVSRPAMDlg::OnInitDialog()
{
        CDialog::OnInitDialog();
        long rc;
        unsigned long      QVSEvtsCookie;
        LPUNKNOWN pUnkSink;
        LPUNKNOWN pUnkSrc;

        EnableAutomation();
        rc = Term.CreateDispatch("QVSRPAM.RPAMTerminal");
        TRACE("\nCreateDispatch rc %#x", rc);
        rc = App.CreateDispatch(_T("QVSRPAM.RPAMApp"));


        pUnkSink = GetIDispatch(false);
        rc = Term.m_lpDispatch->QueryInterface(IID_IUnknown, (void **)(&pUnkSrc));
        rc = AfxConnectionAdvise(pUnkSrc, __uuidof(qvsrpam::_IQVSRPAMEvents), pUnkSink, FALSE, &QVSEvtsCookie);

        App.SetOptimizeDisplay(0);  // we want ALL displays
        App.SetTracing(TRUE);

        App.SetTermNumAssignMode(qvsrpam::rpaAppTermNum);

        Term.SetUnitID(1);
        Term.SetTermNum(1);

        return TRUE;  // return TRUE unless you set the focus to a control
                      // EXCEPTION: OCX Property Pages should return FALSE
}

void CQVSRPAMDlg::OnDisplayEventEx(long Device, LPCTSTR Row1, LPCTSTR Row2, long UpdateFlags)
        {
        if (Device == 0)  // device 0 is ANDISPLAY, device 1 is ANDISPLAY2
                {
                GetDlgItem(IDC_ROW1)->SetWindowText(Row1);
                GetDlgItem(IDC_ROW2)->SetWindowText(Row2);
                }
        }


void CQVSRPAMDlg::OnPrintExEvent( long Station, long Command, long LineFeeds, long DataLen, long Flags, VARIANT *Data)
   {
   if (Command == CMD_END_PRINT)
      {
      Printer.SendPrintRC(Station, 0);
      }
   }
