// 2x20Line.cpp : implementation file
//

#include "stdafx.h"
#include "vcsample.h"
#include "2x20Line.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// C2x20Line

C2x20Line::C2x20Line()
{
   Data = "";
   CWindowDC dc(NULL);
   int ppi;

   ppi = dc.GetDeviceCaps(LOGPIXELSY);
   ppi = (ppi * 14)/72;
   
   // create a fixed font
   m_Font.CreateFont(ppi, 0, 0, 0, FW_BOLD, 0,0,0,
		     DEFAULT_CHARSET, OUT_DEFAULT_PRECIS,
		     CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
		     FF_MODERN, "Courier New");
}

C2x20Line::~C2x20Line()
{
}


BEGIN_MESSAGE_MAP(C2x20Line, CStatic)
	//{{AFX_MSG_MAP(C2x20Line)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// C2x20Line message handlers

void C2x20Line::UpdateData(CString NewData)
{
   Data = NewData;
   Invalidate(true);
}

void C2x20Line::OnPaint()
{
	CPaintDC dc(this); // device context for painting
   CFont *OldFont = (CFont *)dc.SelectObject(&m_Font);
   COLORREF BkColor = dc.GetBkColor();
   COLORREF TextColor = dc.GetTextColor();
   CRect ClientRect;
   GetClientRect(&ClientRect);
   
   dc.SetBkColor(RGB(0,0,0));
   dc.SetTextColor(RGB(0,255,0));
   dc.FillSolidRect(ClientRect, RGB(0,0,0));

   dc.ExtTextOut(ClientRect.left+2,
                 ClientRect.top+2, 
                 ETO_OPAQUE, ClientRect, Data, NULL);

   dc.SetBkColor(BkColor);
   dc.SetTextColor(TextColor);
   dc.SelectObject(OldFont);
}

