// vcsampleDlg.h : header file
//

#if !defined(AFX_VCSAMPLEDLG_H__95D76429_2768_11D4_920E_00C0F0403AD8__INCLUDED_)
#define AFX_VCSAMPLEDLG_H__95D76429_2768_11D4_920E_00C0F0403AD8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "qvsrpam.h"
#include "2x20line.h"

/////////////////////////////////////////////////////////////////////////////
// CVcsampleDlg dialog

class CVcsampleDlg : public CDialog
{
// Construction
public:
	CVcsampleDlg(CWnd* pParent = NULL);	// standard constructor
   
   IRPAMTerminal Term;
   IRPAMApp App;
   IPOSDisplay Display;
   IIOProcessor IOProc;
   IPOSPrinter Printer;
   
   // class to handle print events
   DWORD PrintEvtsCookie;
   CFont m_PrintFont;
   int m_Online;
      
   DWORD DispEvtsCookie;
   void OnDisplayEvent(LONG Device, LPCTSTR Row1Text, LPCTSTR Row2Text);
   void OnOnlineEvent();
   void OnPrintEvent(long Station, LPCTSTR PrintLine, long LineFeeds);

   // Dialog Data
	//{{AFX_DATA(CVcsampleDlg)
	enum { IDD = IDD_VCSAMPLE_DIALOG };
	CListBox	m_CRPrinter;
	C2x20Line	m_Row2;
	C2x20Line	m_Row1;
	BOOL	m_Connect;
	CString	m_UnitID;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVcsampleDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CVcsampleDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnStartterm();
	afx_msg void OnFileop();
	//}}AFX_MSG
   afx_msg void OnBtnClicked(UINT nID);
   DECLARE_MESSAGE_MAP()

   // Generated OLE dispatch map functions
   //{{AFX_DISPATCH(CDispEvts)
          // NOTE - the ClassWizard will add and remove member functions here.
   //}}AFX_DISPATCH
   DECLARE_DISPATCH_MAP()
   DECLARE_INTERFACE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VCSAMPLEDLG_H__95D76429_2768_11D4_920E_00C0F0403AD8__INCLUDED_)
